package cn.org.bjca.trust.pushdemo.controller;

import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.http.HttpHeaders;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.reactive.function.BodyInserters;
import org.springframework.web.reactive.function.client.WebClient;

import java.nio.charset.StandardCharsets;

@RestController
@RequestMapping("hello")
public class HelloController {

    @GetMapping("/{id}")
    public String getById(@PathVariable String id) {
        System.out.println("id ==> " + id);

        WebClient webClient = WebClient.builder().baseUrl("http://127.0.0.1:15672").defaultHeaders(httpHeaders -> httpHeaders.addAll(getHeaders())).build();

        webClient.put().uri("/api/users/{userId}", id)  // 请求路径
                .body(BodyInserters.fromValue("{\n" + "  \"username\": \"" + id + "\",\n" + "  \"password\": \"" + id + "\",\n" + "  \"tags\": \"none\"\n" + "}")).retrieve();

        webClient.put().uri("/api/permissions/{vhost}/{userId}", "/", id)  // 请求路径
                .body(BodyInserters.fromValue("{\n" + "  \"username\": \"" + id + "\",\n" + "  \"vhost\": \"/\",\n" + "  \"configure\": \".*\",\n" + "  \"write\": \".*\",\n" + "  \"read\": \".*\"\n" + "}")).retrieve();
        webClient.put().uri("/api/topic-permissions/{vhost}/{userId}", "/", id)  // 请求路径
                .body(BodyInserters.fromValue("{\n" + "  \"username\": \"" + id + "\",\n" + "  \"vhost\": \"/\",\n" + "  \"exchange\": \"\",\n" + "  \"write\": \".*\",\n" + "  \"read\": \".*\"\n" + "}")).retrieve();


        return "{\n" + "    \"msg\": \"qdxorigin\",\n" + "    \"status\": \"200\",\n" + "    \"data\": \"Sbfuiaefhaikufhcsauik\"\n" + "}";
    }

    String enc = new String(Base64.encodeBase64("admin:admin".getBytes(StandardCharsets.ISO_8859_1), false));
    HttpHeaders headers = null;

    private MultiValueMap<String, String> getHeaders() {

        if (headers == null) {
            headers = new HttpHeaders();
            headers.add(HttpHeaders.AUTHORIZATION, "Basic " + enc);
            headers.add(HttpHeaders.CONTENT_TYPE, "application/json");
        }
        return headers;
    }
}
